﻿using BlueWest.EfMethods.Sources;
using Microsoft.CodeAnalysis;
using System;
using System.Collections.Generic;
using System.Text;

namespace BlueWest.EfMethods.Extensions
{
    internal static class CommonExtensions
    {
        internal static SourceBuilder WriteComment(this SourceBuilder builder, string comment = "")
        {
            return builder.WriteLine($"// {comment}");
        }
        
        internal static SourceBuilder WriteCommentArray(this SourceBuilder builder, IEnumerable<object> enumerable, string name = "")
        {
            builder.WriteComment($"Printing Array: {name}");
            foreach (var o in enumerable)
            {
                if (o != null)
                {
                    builder.WriteComment($"     {o.ToString()}");
                }
            }
            builder.WriteComment($"End printing Array: {name}");

            return builder;
        }
    }
}
